// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: CachedIndexFile.h,v 0.9 1997-12-27 07:07:27+09 harada Exp $
//
#ifndef CACHEDINDEXFILE_H_INCLUDED
#define CACHEDINDEXFILE_H_INCLUDED

#include "IndexFile.h"

class CachedIndexFile : public IndexFile {
protected:
    int *lruQ;
    int maxpageNum;
    int pageNum;
    int sync_need;
    struct cache_entry_t {
        char *buffer;
        blockno_t bn;
        size_t size;
    } *entries;
    
    void sync();
    int findPage(blockno_t bn);
    int liftup(int p, int hint = -1);
    int pushout(int &hint);
    int readBlock(char *buf, blockno_t bn, size_t size = BLOCKSIZE);
    int writeBlock(const char *buf, blockno_t bn, size_t size = BLOCKSIZE);
public:
    CachedIndexFile(int maxpage, fstream &file, int rdonlyp, int newfilep);
    virtual ~CachedIndexFile();
};

#endif
