// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Description.h,v 0.9 1997-12-27 07:10:14+09 harada Exp $
//
#ifndef DESCRIPTION_H_INCLUDED
#define DESCRIPTION_H_INCLUDED

#include <iostream.h>
#include <fstream.h>
#include "Result.h"
#include "config.h"

class Description {
protected:
    fstream &file;
    const int blksize;
public:
    Description(fstream &f, int bs = DSCBLOCKSIZE) : file(f), blksize(bs) { }
    virtual ~Description() {
        if(file.is_open()) file.close();
    }
    virtual void print(ostream &out, const Result &result) = 0;
};

class HtmlDescription : public Description {
protected:
    void getblock(int n, time_t &tm, size_t &sz, char *url, 
                  char *author, char *title, char *digest);
public:
    HtmlDescription(fstream &f) : Description(f, DSCBLOCKSIZE) { }
    virtual ~HtmlDescription() { }
    virtual void print(ostream &out, const Result &result);
    virtual void printHtml(ostream &out, const Result &result);
};

class MailDescription : public Description {
public:
    MailDescription(fstream &f) : Description(f, DSCBLOCKSIZE) { }
    virtual ~MailDescription() { }
    virtual void print(ostream &out, const Result &result);
};

#endif
