// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Indexer.h,v 0.9 1997-12-27 07:18:23+09 harada Exp $
//
#ifndef INDEXER_H_INCLUDED
#define INDEXER_H_INCLUDED

#include <iostream.h>
#include "typedef.h"
#include "WordBreaker.h"
#include "HashBag.h"
#include "Unifier.h"
#include "IndexFile.h"
#include "LexiconFile.h"

class Indexer {
private:
    WordBreaker &breaker;
    const Unifier &unifier;

    int buildindex(LexiconFile &lexfile, IndexFile &idxfile,
                   HashBag<valueSet<pos_t> > &hashbuf);
    static void makefilename(char *lexfilename, char *idxfilename,
                             const char *basename, int nth);
    void output_mapentry(ostream &xmapfile, pos_t base, size_t typeoffset[]);
    void deentitize(char *dst, const char *src);
    virtual void output_last_mapentry(ostream &xmapfile, pos_t offset);

public:
    Indexer(WordBreaker &wb, const Unifier &unif);
    virtual ~Indexer();
    int processText(istream &source, LexiconFile &lexfile, IndexFile &idxfile,
                    fstream &xmapfile, pos_t &offset);

    int makeIndices(istream &source, const char *basename,
                   fstream &xmapfile, pos_t &offset);
    static int mergeIndices(const char *newbase,
                            const char *tmpbase, int tmpNum);
    static int mergeFiles(LexiconFile *newlexicon, IndexFile *newindex,
                          int n, LexiconFile *lexicons[],
                          IndexFile *indices[], size_t *shifttbl = NULL);

    virtual void printDebug(ostream &out = cout) const;
};

#endif
