// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Retriever.h,v 0.9 1997-12-27 07:24:16+09 harada Exp $
//
#ifndef RETRIEVER_H_INCLUDED
#define RETRIEVER_H_INCLUDED

#include <iostream.h>
#include "typedef.h"
#include "LexiconFile.h"
#include "IndexFile.h"
#include "Result.h"
#include "XMap.h"

class Retriever {
private:
    LexiconFile &lexiconfile;
    IndexFile &indexfile;
    const XMap &xmap;
    pos_t *searchWord(const char *key, int &resultLen);
    pos_t *prefixsearchWord(const char *key, int &resultLen);
    pos_t *searchJapaneseWord(const char *key, int &resultLen,
                              int isprefixsearch = 0);
    Result *translateList(const pos_t *list, int listLen,
                          int &resultLen, int type);
public:
    Retriever(LexiconFile &lex, IndexFile &idxfile, const XMap &map);
    ~Retriever();
    pos_t *searchPhrase(char **keys, int offsets[],
                        int nkeys, int &resultLen, int isprefixsearch = 0);
    pos_t *search(const char *text, int &resultLen, int isprefixsearch = 0);

    Result *retrievePhrase(char **keys, int *offsets,
                           int nkeys, int &resultLen, int type);
    Result *retrieve(const char *text, int &resultLen,
                     int type, int isprefixsearch = 0);
};

#endif
