// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// address translator (mapping)
// $Id: XMap.h,v 0.11 1997-12-29 15:13:43+09 harada Exp $
//
#ifndef XMAP_H_INCLUDED
#define XMAP_H_INCLUDED

#include <iostream.h>
extern "C" {
#include <sys/types.h>
#include <sys/mman.h>
}
#include "typedef.h"

#ifdef SUNOS4
extern "C" caddr_t mmap(caddr_t addr, size_t len, int prot,
                    int flags, int fd, off_t off);
extern "C" int munmap(caddr_t addr, int len);
#endif

class XMap {
private:
    const int fd;
    int *scores;
    caddr_t mapaddr;
    size_t mapsize;
    int entryNum;
    pos_t maxoffset;
    getMaxAssigned() const;
    int findEntry(pos_t pos) const;
    pos_t getbase(int n) const{
        return *(pos_t *)((char *)mapaddr + ENTRYSIZE * n);
    }
public:
    enum { TYPENUM = 6, ENTRYSIZE = 4 + 2 * 6 };
    XMap(int filedesc);
    ~XMap();
    operator bool() const { return (caddr_t)(-1) != mapaddr; }
    int translate(pos_t pos, urlid_t &urlid, size_t &offset, int &type) const;
    int getdocsize(int n) const;
    int getdocNum() const { return entryNum; }
    int score(int type) const;
    void printDebug(ostream &out = cout) const;
};

inline int
XMap::score(int type) const{
    assert(type >= 0);
    assert(type <= TYPENUM);
    return scores[type];
}

inline int
XMap::getdocsize(int n) const{
    if(n < 0 || entryNum <= n) return -1;
    return getbase(n + 1) - getbase(n);
}

#endif

// ե readonly Ȥmmap롣
// .mapեΤ̤Υץ(Ūˤϸ­Ƥ)

// ե륵 (ºݤURL + 1)16byte
// Ǹ16byteֿͤȤߤκΥɥ쥹ؤ̣ġ
